unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;


type
//=============================================================================
     Noeud=
        class
           private
              Fils    : array['A'..'Z'] of Noeud;  //liste de fils
              x,y : integer ;  // pour dessin arbre
              Lettre  : char ;       // lettre contenue dans ce noeud de l'arbre
              Entier  : boolean;     //flag indiquant si le mot est entier
           public
              constructor create ;
              destructor destroy ;
        end; { Noeud }

    //arbre d'ordre 26
    Arbre =
        class
           private
              tete,courant : noeud ;
           public
              constructor create ;
              destructor destroy ;override ;
              procedure charger(NomFic : string) ;
              procedure rajouter_mot(LeMot : string) ;
              procedure Affiche(S{,prefixe} :string);
              function  Trouve(LeMot: string) : boolean;
              function  compter_terminaux(en_cours : noeud) : integer ;
              procedure dessine(en_cours : noeud ;limg,old_x,old_y : integer) ;
        end ;
//=============================================================================

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TRichEdit;
    Button4: TButton;
    Image1: TImage;
    Button5: TButton;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  dico1 : arbre ;

implementation

{$R *.DFM}

constructor noeud.create ;
var c : char ;
begin
for c:='A' to 'Z' do
    fils[c]:=nil ;
lettre:=#0 ;
entier:=false ;
end ;

destructor noeud.destroy ;
var c : char ;
begin
for c:='A' to 'Z' do if fils[c]<>nil then fils[c].destroy ;
inherited destroy ;
end ;

constructor arbre.create ;
var i : integer ;
    c : char ;
begin
tete:=noeud.create ;
courant:=tete ;
end ;

destructor arbre.destroy ;
begin
tete.destroy ;
inherited destroy ;
end ;

procedure arbre.rajouter_mot(LeMot : string) ;
var lettre : char ;
begin
if LeMot='' then
   begin
   courant.entier:=true;
   exit ;
   end;
lettre:=LeMot[1] ;
if courant.fils[lettre]<>nil then  // si la lettre existe dj
   courant:=courant.fils[lettre]   // alors on se positionne sur la lettre suivante
else  // sinon il faut crer cette lettre dans l'arbre
   begin
   courant.fils[lettre]:=noeud.create ;
   courant:=courant.fils[lettre] ;
   courant.lettre:=lettre ;  // la lettre est maintenant dans l'arbre
   end ;
delete(LeMot,1,1) ;  // on efface la lettre du mot puisqu'elle est dj dans l'arbre
rajouter_mot(LeMot) ; // et on rajoute le reste
end ;

procedure arbre.charger(NomFic : string) ;
var   s,chemin : string ;
       f : textfile ;
begin
// chargement du dico
chemin:=ExtractFilePath(Application.ExeName); {le chemin de l'appli, AVEC l'antislash final}
assignFile(f,chemin+nomFic) ;
reset(f) ;
repeat
    readln(f,s) ;
    courant:=tete ;  // on se positionne en tte de l'arbre
    rajouter_mot(s) ;  // et on rajoute le mot
until eof(f) ;
closeFile(f) ;
end ;


function arbre.trouve(LeMot : string) : boolean ;
var lettre : char ;
begin
if LeMot='' then  //--- incomplet ; tester aussi "entier"
   trouve:=true
else
   begin
   lettre:=LeMot[1] ;
   delete(LeMot,1,1) ;
   if courant.fils[lettre]=nil then
      trouve:=false
   else
      begin
      courant:=courant.fils[lettre] ;
      trouve:=trouve(LeMot) ;
      end ;
   end ;
end ;

function arbre.compter_terminaux(en_cours : noeud) : integer ;
var i     : char ;
    total : integer ;
begin  // fonction valable aussi pour un arbre non quilibr
total:=0 ;
for i:='A' to 'Z' do
    if en_cours.fils[i]<>nil then
       inc(total,compter_terminaux(en_cours.fils[i])) ;
if total=0 then inc(total) ;
compter_terminaux:=total ;
end ;


procedure arbre.Affiche(S: string);
var i   : char ;
    aux : noeud;
begin
    if courant.Entier then Form1.Memo1.Lines.Add(s);
    for i := 'A' to 'Z' do
      if courant.fils[i]<>nil then
         begin
         aux:=courant;
         courant:=courant.fils[i];
         Affiche(S+i);
         courant:=aux;
         end; { courant.fils[i]<>nil }
end;


procedure arbre.dessine(en_cours : noeud ;limg,old_x,old_y : integer) ;
var x,y,nb : integer ;
    i      : char ;
begin  // on suppose 50 pixels par lettre en largeur et 80 en hauteur
//nb:=compter_terminaux(courant) ; // remplacer par cette ligne la suivante : joli
  // a c'est arriv par hasard ; j'avais oubli de remplacer "courant" par "en_cours"
  // et j'ai obtenu un affichage diffrent ; penser  augmenter la taille de l'image
nb:=compter_terminaux(en_cours) ;
x:=limg+(50*nb) div 2 ;
//y:=niveau*80 ;
y:=old_y+80 ;
if en_cours<>tete then
   with form1.image1.picture.bitmap.canvas do
      begin
      textout(x,y,en_cours.lettre) ;
      en_cours.x:=x ;en_cours.y:=y ;
      moveto(x,y-5) ;lineto(old_x,old_y) ;
      end ;
for i:='A' to 'Z' do
    if en_cours.fils[i]<>nil then
       begin
       nb:=compter_terminaux(en_cours.fils[i]) ;
       dessine(en_cours.fils[i],limg,x,y+20) ;
       limg:=limg+nb*50 ;
       end ;
end ;

//=============================================================================

procedure TForm1.FormCreate(Sender: TObject);
begin
dico1:=arbre.create ;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin  // charger dico
Screen.Cursor:=crHourGlass;
dico1.charger('dico1.txt') ;
Screen.Cursor:=crDefault;
end;

procedure TForm1.Button3Click(Sender: TObject);
var mot:string;
begin
mot:=Uppercase(InputBox('Chercher','Mot','XXXXX'));
dico1.courant:=dico1.tete ;
if dico1.trouve(mot) then ShowMessage('Trouv !') else ShowMessage('Pas trouv !');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     //reconstitution du dico  partir de l'arbre
     Screen.Cursor:=crHourGlass;
     Memo1.Clear;
     dico1.courant:=dico1.tete;
     dico1.Affiche('');
     showmessage(inttostr(Memo1.Lines.count));
     Screen.Cursor:=crDefault;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
Dico1.Destroy;
end;

procedure TForm1.Button4Click(Sender: TObject);
var b : tbitmap ;
begin
     //"dessin" de l'arbre
     Screen.Cursor:=crHourGlass;
     b:=tbitmap.create ;
     b.width:=800;
     b.height:=530 ;
     with b.canvas do
          begin
          Brush.style:=bsSolid ;
          Brush.color:=clWhite ;
          rectangle(0,0,799,529) ;
          pen.color:=clBlack ;
          font.name:='fixedsys' ;
          end ;
     image1.picture.bitmap:=b ;
     // on ne doit pas dsallouer "b" car il appartient maintenant  image1
     // qui sera dtruite lors de "form1.destroy"
     dico1.courant:=dico1.tete;  // positionnement
     dico1.dessine(dico1.tete,0,0,-80) ;
     Screen.Cursor:=crDefault;
end;

procedure TForm1.Button5Click(Sender: TObject);
var nb:integer;
begin
     Screen.Cursor:=crHourGlass;
     nb:=dico1.compter_terminaux(dico1.tete);
     Screen.Cursor:=crDefault;
     Showmessage(IntToStr(nb));
end;

end.
